﻿namespace SwiftEmu
{
    using SwiftEmu.Core;
    using SwiftEmu.HabboHotel;
    using SwiftEmu.HabboHotel.GameClients;
    using SwiftEmu.HabboHotel.Habbo.Guilds;
    using SwiftEmu.HabboHotel.Habbo.Users;
    using SwiftEmu.HabboHotel.Pets;
    using SwiftEmu.HabboHotel.Users.UserDataManagement;
    using SwiftEmu.Messages;
    using SwiftEmu.Messages.ClientMessages;
    using SwiftEmu.Messages.StaticMessageHandlers;
    using SwiftEmu.Net;
    using Database_Manager.Database;
    using Database_Manager.Database.Session_Details.Interfaces;
    using HabboEncryption;
    using HabboEvents;
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.Globalization;
    using System.IO;
    using System.Text;
    using System.Windows.Forms;
    using System.Text.RegularExpressions;

    internal static class SwiftEmuEnvironment
    {
        internal static bool Activated = false;
        private static readonly List<char> allowedchars = new List<char>(new char[] { 
            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 
            'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '1', '2', '3', '4', '5', '6', 
            '7', '8', '9', '0', '-', '.'
         });
        private static ConfigurationData Configuration;
        private static ConnectionHandeling ConnectionManager;
        internal static CultureInfo cultureInfo;
        private static BigInteger d = new BigInteger("59AE13E243392E89DED305764BDD9E92E4EAFA67BB6DAC7E1415E8C645B0950BCCD26246FD0D4AF37145AF5FA026C0EC3A94853013EAAE5FF1888360F4F9449EE023762EC195DFF3F30CA0B08B8C947E3859877B5D7DCED5C8715C58B53740B84E11FBC71349A27C31745FCEFEEEA57CFF291099205E230E0C7C27E8E1C0512B", 0x10);
        internal static DatabaseType dbType;
        private static Encoding DefaultEncoding;
        internal static bool diagPackets = false;
        internal static bool DisconectLog = false;
        private static BigInteger e = new BigInteger(3L);
        public static uint friendRequestLimit = 300;
        private static SwiftEmu.HabboHotel.Game Game;
        public static uint giftInt = 0x242;
        internal static HabboCrypto globalCrypto;
        internal static bool groupsEnabled;
        internal static string HotelStreamMessage = "";
        internal static string InteralLicense = "";
        internal static bool IrcEnabled;
        internal static bool isLive;
        internal static bool AllowPacketlog = true;
        internal static string LinkConfig;
        internal static string HotelLink;
        private static DatabaseManager manager;
        private static DatabaseManager managerItems;
        internal static MusSocket MusSystem;
        private static BigInteger n = new BigInteger("86851DD364D5C5CECE3C883171CC6DDC5760779B992482BD1E20DD296888DF91B33B936A7B93F06D29E8870F703A216257DEC7C81DE0058FEA4CC5116F75E6EFC4E9113513E45357DC3FD43D4EFAB5963EF178B78BD61E81A14C603B24C8BCCE0A12230B320045498EDC29282FF0603BC7B7DAE8FC1B05B52B2F301A9DC783B7", 0x10);
        internal const string PrettyVersion = "Swift";
        internal static string publicToken;
        internal static bool SeparatedTasksInGameClientManager = false;
        internal static bool SeparatedTasksInMainLoops = false;
        internal static int ServerRelease = 1;
        internal static DateTime ServerStarted;
        private static bool ShutdownInitiated = false;
        internal static bool spamBans = false;
        internal static int spamBans_limit = 20;
        internal static string StreamLink;
        internal static bool SystemMute;
        internal static int timeout = 500;
        private static Dictionary<uint, Habbo> usersCached = new Dictionary<uint, Habbo>();
        internal static bool useSSO;
        internal static string secretKey = "12844543231839046982589043811871065476910599239608903221675649771360705087933";//old: 24231219992253632572058933470468103090824667747608911151318774416044820318109
        internal static int MaxDucket = 6500;
        internal static int SSOTicketAuth = 1;
        internal static int SSOTicketUser = 1;
        internal static int MaxSocket = 1;
        internal static string HotelSWFLink = "/swfs/";

        internal static void AppendTimeStampWithComment(ref StringBuilder builder, DateTime time, string text)
        {
            builder.AppendLine(text + " =>[" + TimeSpanToString((TimeSpan) (DateTime.Now - time)) + "]");
        }

        internal static string BoolToEnum(bool Bool)
        {
            if (Bool)
            {
                return "1";
            }
            return "0";
        }

        internal static void Destroy()
        {
            isLive = false;
            Logging.WriteLine("Encerrando Emulação do swift...");
            if (GetGame() != null)
            {
                GetGame().Destroy();
                Game = null;
            }
            if (GetConnectionManager() != null)
            {
                Logging.WriteLine("Encerrando Gerenciador de conexões.");
                GetConnectionManager().Destroy();
            }
            if (manager != null)
            {
                try
                {
                    Logging.WriteLine("Encerrando conexão com banco de Dados.");
                    manager.destroy();
                }
                catch
                {
                }
            }
            Logging.WriteLine("Encerramento Concluído! Fechando.");
        }

        internal static bool EnumToBool(string Enum)
        {
            return (Enum == "1");
        }

        internal static string FilterFigure(string figure)
        {
            foreach (char ch in figure)
            {
                if (!isValid(ch))
                {
                    return "lg-3023-1335.hr-828-45.sh-295-1332.hd-180-4.ea-3168-89.ca-1813-62.ch-235-1332";
                }
            }
            return figure;
        }

        internal static string MySQLEscape(string str)
        {
            return Regex.Replace(str, @"[\x00'""\b\n\r\t\cZ\\%_]",
                delegate(Match match)
                {
                    string v = match.Value;
                    switch (v)
                    {
                        case "\x00":            // ASCII NUL (0x00) character
                            return "\\0";
                        case "\b":              // BACKSPACE character
                            return "\\b";
                        case "\n":              // NEWLINE (linefeed) character
                            return "\\n";
                        case "\r":              // CARRIAGE RETURN character
                            return "\\r";
                        case "\t":              // TAB
                            return "\\t";
                        case "\u001A":          // Ctrl-Z
                            return "\\Z";
                        default:
                            return "\\" + v;
                    }
                });
        } 

        internal static string FilterInjectionChars(string Input)
        {
            Input = Input.Replace((char)1, ' ');
            Input = Input.Replace((char)2, ' ');
            Input = Input.Replace((char)3, ' ');
            Input = Input.Replace((char)9, ' ');
            return Input;
        }

        internal static string FilterInjectionChars(string Input, bool AllowLinebreaks)
        {
            if (Input == null)
            {
                return null;
            }


            return Regex.Replace(Input, @"[\r\n\x00\x1a\\'""]", @"\$0");
        }

        internal static ConfigurationData GetConfig()
        {
            return Configuration;
        }

        internal static ConfigurationData GetDBConfig()
        {
            return DatabaseConfiguration;
        }
        internal static ConnectionHandeling GetConnectionManager()
        {
            return ConnectionManager;
        }

        internal static DatabaseManager GetDatabaseManager()
        {
            return manager;
        }

        internal static DatabaseManager GetDatabaseManagerItems()
        {
            return managerItems;
        }

        internal static Encoding GetDefaultEncoding()
        {
            return DefaultEncoding;
        }

        internal static SwiftEmu.HabboHotel.Game GetGame()
        {
            return Game;
        }

        internal static Habbo getHabboForId(uint UserId)
        {
            try
            {
                GameClient clientByUserID = GetGame().GetClientManager().GetClientByUserID(UserId);
                if (clientByUserID != null)
                {
                    Habbo habbo = clientByUserID.GetHabbo();
                    if ((habbo != null) && (habbo.Id > 0))
                    {
                        if (usersCached.ContainsKey(UserId))
                        {
                            usersCached.Remove(UserId);
                        }
                        return habbo;
                    }
                }
                else
                {
                    if (usersCached.ContainsKey(UserId))
                    {
                        return usersCached[UserId];
                    }
                    UserData userData = UserDataFactory.GetUserData((int) UserId);
                    Habbo user = userData.user;
                    if (user != null)
                    {
                        user.InitInformation(userData);
                        usersCached.Add(UserId, user);
                        return user;
                    }
                }
                return null;
            }
            catch
            {
                return null;
            }
        }

        internal static Habbo getHabboForName(string UserName)
        {
            try
            {
                using (IQueryAdapter adapter = GetDatabaseManager().getQueryreactor())
                {
                    adapter.setQuery("SELECT id FROM users WHERE username = '" + UserName + "'");
                    int num = adapter.getInteger();
                    if (num > 0)
                    {
                        return getHabboForId((uint) num);
                    }
                }
                return null;
            }
            catch
            {
                return null;
            }
        }

        internal static int GetRandomNumber(int Min, int Max)
        {
            RandomBase base2 = new Quick();
            return base2.Next(Min, Max);
        }

        internal static int GetUnixTimestamp()
        {
            TimeSpan span = (TimeSpan) (DateTime.UtcNow - new DateTime(0x7b2, 1, 1, 0, 0, 0));
            return (int) span.TotalSeconds;
        }

        internal static void Initialize()
        {
            Console.WindowHeight = 30;
            Console.WindowWidth = 80;
            Console.ResetColor();
            Console.Clear();
            Console.BackgroundColor = ConsoleColor.Blue;
            DateTime now = DateTime.Now;
            SystemMute = false;
            IrcEnabled = false;
            ServerStarted = DateTime.Now;
            Console.BackgroundColor = ConsoleColor.Red;
            Console.ForegroundColor = ConsoleColor.Black;
            Console.WriteLine(@"                                                                               ");
            Console.WriteLine(@"                    Atenção! Emulador em Desenvolvimento                       ");
            Console.WriteLine(@"_______________________________________________________________________________");
            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.Blue;
            Console.WriteLine(@"                                                                               ");
            Console.WriteLine(@"         #####  W       W  II  FFFFFF TTTTTTT                                  ");
            Console.WriteLine(@"         #      W       W      F         T             [                    ]  ");
            Console.WriteLine(@"         #      W       W  II  F         T             [ the m0vame project ]  ");
            Console.WriteLine(@"         #####  W  WWW  W  II  FFFF      T             [  www.bi0s.com.br   ]  ");
            Console.WriteLine(@"             #  W  W W  W  II  F         T             [                    ]  ");
            Console.WriteLine(@"             #  W  W w  W  II  F         T                                     ");
            Console.WriteLine(@"         #####  WWWW WWWW  II  F         T                                     ");
            Console.WriteLine(@"_______________________________________________________________________________");
            Console.BackgroundColor = ConsoleColor.Black;
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("                 Versão Brasileira - Edição por bi0s                            ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine();
            Console.ForegroundColor = ConsoleColor.Gray;
            Console.Title = "[Swift] Sistemas -> Carregando!";
            DefaultEncoding = Encoding.Default;
            //Logging.WriteLine("");
            cultureInfo = CultureInfo.CreateSpecificCulture("pt-BR");
            Logging.LogMessage(@"[Swift] Emulador Sendo Iniciado ");
            LanguageLocale.Init();
            try
            {
                publicToken = new BigInteger(DiffieHellman.GenerateRandomHexString(15), 0x10).ToString();
                globalCrypto = new HabboCrypto(n, e, d);
                ChatCommandRegister.Init();
                PetCommandHandeler.Init();
                PetLocale.Init();
                Configuration = new ConfigurationData(Path.Combine(Application.StartupPath, "Configuracao/emulador.ini"), false);
                DatabaseConfiguration = new ConfigurationData(Path.Combine(Application.StartupPath, "Configuracao/database.ini"), false);
                DateTime time2 = DateTime.Now;
                Logging.WriteLine("[Swift] Conectando ao Banco de Dados");
                dbType = (GetConfig().data.ContainsKey("db.mssql") && (GetConfig().data["db.mssql"] == "true")) ? DatabaseType.MSSQL : DatabaseType.MySQL;
                HotelLink = GetConfig().data["hotel.link"];
                LinkConfig = GetConfig().data["guilds.link"];
                StreamLink = GetConfig().data["stream.link"];
                HotelStreamMessage = GetConfig().data["hotel.stream.message"];
                MaxDucket = Convert.ToInt32(GetConfig().data["ducket.upper.limit"]);
                MaxSocket = Convert.ToInt32(GetConfig().data["game.tcp.conlimit"]);
                SSOTicketAuth = Convert.ToInt32(GetConfig().data["sso.auth_ticekt"]);
                SSOTicketUser = Convert.ToInt32(GetConfig().data["sso.user_tickets"]);
                AllowPacketlog = Convert.ToBoolean(GetConfig().data["allow.packetlog"]);
                HotelSWFLink = Convert.ToString(GetConfig().data["hotel.swf.url"]);
                // Database Manager
                manager = new DatabaseManager(uint.Parse(GetDBConfig().data["db.pool.maxsize"]), int.Parse(GetDBConfig().data["db.pool.minsize"]), dbType);
                manager.setServerDetails(GetDBConfig().data["db.hostname"], uint.Parse(GetDBConfig().data["db.port"]), GetDBConfig().data["db.username"], GetDBConfig().data["db.password"], GetDBConfig().data["db.name"]);
                manager.init();
                // Database Items Manager
                managerItems = new DatabaseManager(uint.Parse(GetDBConfig().data["db.items.pool.maxsize"]), int.Parse(GetDBConfig().data["db.items.pool.minsize"]), dbType);
                managerItems.setServerDetails(GetDBConfig().data["db.items.hostname"], uint.Parse(GetDBConfig().data["db.items.port"]), GetDBConfig().data["db.items.username"], GetDBConfig().data["db.items.password"], GetDBConfig().data["db.items.name"]);
                managerItems.init();
                TimeSpan span = (TimeSpan) (DateTime.Now - time2);
                Logging.WriteLine(string.Concat(new object[] { "Connectado ao Banco de Dados! (", span.Seconds, " segundos, ", span.Milliseconds, " milisegundos)" }));
                LanguageLocale.InitSwearWord();
                friendRequestLimit = (uint) int.Parse(GetConfig().data["client.maxrequests"]);
                GuildsPartsData.InitGroups();
                Game = new SwiftEmu.HabboHotel.Game(int.Parse(GetConfig().data["game.tcp.conlimit"]));
                Game.ContinueLoading();
                ConnectionManager = new ConnectionHandeling(int.Parse(GetConfig().data["game.tcp.port"]), int.Parse(GetConfig().data["game.tcp.conlimit"]), int.Parse(GetConfig().data["game.tcp.conperip"]), GetConfig().data["game.tcp.enablenagles"].ToLower() == "true");
                ConnectionManager.init();
                ConnectionManager.Start();
                StaticClientMessageHandler.Initialize();
                ClientMessageFactory.Init();
                string[] strArray = GetConfig().data["mus.tcp.allowedaddr"].Split(new char[] { Convert.ToChar(",") });
                MusSystem = new MusSocket(GetConfig().data["mus.tcp.bindip"], int.Parse(GetConfig().data["mus.tcp.port"]), strArray, 0);
                groupsEnabled = false;
                //if (Configuration.data.ContainsKey("groups.enabled") && (Configuration.data["groups.enabled"] == "true"))
                //{
                    groupsEnabled = true;
                //}
                useSSO = true;
                //if (Configuration.data.ContainsKey("auth.ssodisabled") && (Configuration.data["auth.ssodisabled"] == "false"))
                //{
                //    useSSO = false;
                //}
                if (Configuration.data.ContainsKey("spambans.enabled") && (Configuration.data["spambans.enabled"] == "true"))
                {
                    spamBans = true;
                    spamBans_limit = Convert.ToInt32(Configuration.data["spambans.limit"]);
                    //Logging.WriteLine("Spam Bans enabled");
                }
                if (Configuration.data.ContainsKey("SeparatedTasksInMainLoops.enabled") && (Configuration.data["SeparatedTasksInMainLoops.enabled"] == "true"))
                {
                    SeparatedTasksInMainLoops = true;
                    //Logging.WriteLine("MultiTasking in MainLoop");
                }
                if (Configuration.data.ContainsKey("SeparatedTasksInGameClientManager.enabled") && (Configuration.data["SeparatedTasksInGameClientManager.enabled"] == "true"))
                {
                    SeparatedTasksInGameClientManager = true;
                    //Logging.WriteLine("MultiTasking in ClientManager");
                }
                Logging.LogMessage(@"[Swift] Emulador Ligou Corretamente ");
                TimeSpan span2 = (TimeSpan) (DateTime.Now - now);
                Logging.WriteLine(string.Concat(new object[] { "[Swift] Emulador -> Pronto! Em: (", span2.Seconds, " segundos, ", span2.Milliseconds, " milisegundos)" }));
                Console.WriteLine();
                Console.BackgroundColor = ConsoleColor.Blue;
                Console.Beep();
                Console.WriteLine(@"                                                                               ");
                Console.WriteLine(@"[Swift] Estamos Prontos , Vamos Lá?                                            ");
                Console.WriteLine(@"_______________________________________________________________________________");
                Console.BackgroundColor = ConsoleColor.Black;
                Console.WriteLine();
                Console.Write("[Swift]> ");
                using (IQueryAdapter adapter = GetDatabaseManager().getQueryreactor())
                {
                    adapter.runFastQuery(string.Concat(new object[] { "UPDATE server_status SET bannerdata='", globalCrypto.Prime, ":", globalCrypto.Generator, "';" }));
                }
                //Logging.WriteLine("GlobalCrypto keys set in SQL.");
                isLive = true;
                //if (Debugger.IsAttached)
                //{
                //    Console.ForegroundColor = ConsoleColor.Yellow;
                //    Logging.WriteLine("Server is debugging: Console writing enabled");
                //    Console.ForegroundColor = ConsoleColor.White;
                //}
                //else
                //{
                //    Logging.WriteLine("Server is not debugging: Console writing disabled");
                //    Logging.DisablePrimaryWriting(false);
                //}
            }
            catch (KeyNotFoundException exception)
            {
                Logging.WriteLine("Está Faltando algo no Arquivo de Configuração!.");
                Logging.WriteLine("Press any key to shut down ...");
                Logging.WriteLine(exception.ToString());
                Console.ReadKey(true);
                Destroy();
            }
            catch (InvalidOperationException exception2)
            {
                Logging.WriteLine("Erro ao Iniciar o SwiftEmu (Exceção): " + exception2.Message);
                Logging.WriteLine("Press any key to shut down ...");
                Console.ReadKey(true);
                Destroy();
            }
            catch (Exception exception3)
            {
                Console.WriteLine("Erro Fatal ao Iniciar! : " + exception3.ToString());
                Console.WriteLine("Press a key to exit");
                Console.ReadKey();
                Environment.Exit(1);
            }
        }

        private static bool isValid(char character)
        {
            return allowedchars.Contains(character);
        }

        internal static bool IsValidAlphaNumeric(string inputStr)
        {
            if (string.IsNullOrEmpty(inputStr))
            {
                return false;
            }
            for (int i = 0; i < inputStr.Length; i++)
            {
                if (!(char.IsLetter(inputStr[i]) || char.IsNumber(inputStr[i])))
                {
                    return false;
                }
            }
            return true;
        }

        internal static void PreformShutDown()
        {
            PreformShutDown(true);
        }

        internal static void PreformShutDown(bool ExitWhenDone)
        {
            if (!ShutdownInitiated && isLive)
            {
                StringBuilder builder = new StringBuilder();
                DateTime now = DateTime.Now;
                DateTime time = DateTime.Now;
                ShutdownInitiated = true;
                SendMassMessage(LanguageLocale.GetValue("shutdown.alert"));
                AppendTimeStampWithComment(ref builder, time, "Hotel pre-warning");
                Game.StopGameLoop();
                Logging.WriteLine("Emulador de Jogo Encerrado");
                DateTime time3 = DateTime.Now;
                Logging.WriteLine("Swift Encerrando..");
                Console.Title = "SwiftEmu! Desligando..";
                GetConnectionManager().Destroy();
                Logging.WriteLine("Conexões Sockets Desligadas");
                DateTime time4 = DateTime.Now;
                GetGame().GetClientManager().CloseAll();
                Logging.WriteLine("Mobis e Itens do Catálogo Salvos");
                DateTime time5 = DateTime.Now;
                Logging.WriteLine("SwiftEmu! Desligando.. <<Processo de Salvamento:");
                Game.GetRoomManager().RemoveAllRooms();
                Logging.WriteLine("Destruindo Quartos");
                DateTime time6 = DateTime.Now;
                using (IQueryAdapter adapter = manager.getQueryreactor())
                {
                    adapter.runFastQuery("TRUNCATE TABLE user_online");
                    adapter.runFastQuery("TRUNCATE TABLE room_active");
                }
                Logging.WriteLine("Banco de Dados Salvo..");
                DateTime time7 = DateTime.Now;
                ConnectionManager.Destroy();
                Logging.WriteLine("Encerrando Conexões de Usuários..");
                DateTime time8 = DateTime.Now;
                Game.Destroy();
                Logging.WriteLine("Emulação de Jogo Encerrando..");
                DateTime time9 = DateTime.Now;
                try
                {
                    Logging.WriteLine("Encerrando Conexões..");
                    manager.destroy();
                    managerItems.destroy();
                    Game.StopLoading();
                }
                catch
                {
                }
                AppendTimeStampWithComment(ref builder, time9, " (Encerramento da DB)");
                TimeSpan span = (TimeSpan) (DateTime.Now - now);
                builder.AppendLine("Tempo de Desligamento " + TimeSpanToString(span));
                builder.AppendLine("You have reached ==> [END OF SESSION]");
                builder.AppendLine();
                builder.AppendLine();
                builder.AppendLine();
                Logging.LogShutdown(builder);
                Logging.WriteLine("[Swift] Encerrado Adeus ;)");
                if (ExitWhenDone)
                {
                    Environment.Exit(Environment.ExitCode);
                }
            }
        }

        internal static void PreformShutDown2()
        {
            PreformShutDown2(true);
        }

        internal static void PreformShutDown2(bool ExitWhenDone)
        {
            if (!ShutdownInitiated && isLive)
            {
                StringBuilder builder = new StringBuilder();
                DateTime now = DateTime.Now;
                DateTime time = DateTime.Now;
                ShutdownInitiated = true;
                SendMassMessage(LanguageLocale.GetValue("shutdown.alert"));
                AppendTimeStampWithComment(ref builder, time, "Hotel pre-warning");
                Game.StopGameLoop();
                Logging.WriteLine("Emulador de Jogo Encerrado");
                DateTime time3 = DateTime.Now;
                Logging.WriteLine("Swift Encerrando..");
                Console.Title = "SwiftEmu! Desligando..";
                GetConnectionManager().Destroy();
                Logging.WriteLine("Conexões Sockets Desligadas");
                DateTime time4 = DateTime.Now;
                GetGame().GetClientManager().CloseAll();
                Logging.WriteLine("Mobis e Itens do Catálogo Salvos");
                DateTime time5 = DateTime.Now;
                Logging.WriteLine("SwiftEmu! Desligando.. <<Processo de Salvamento:");
                Game.GetRoomManager().RemoveAllRooms();
                Logging.WriteLine("Destruindo Quartos");
                DateTime time6 = DateTime.Now;
                using (IQueryAdapter adapter = manager.getQueryreactor())
                {
                    adapter.runFastQuery("TRUNCATE TABLE user_online");
                    adapter.runFastQuery("TRUNCATE TABLE room_active");
                }
                Logging.WriteLine("Banco de Dados Salvo..");
                DateTime time7 = DateTime.Now;
                ConnectionManager.Destroy();
                Logging.WriteLine("Encerrando Conexões de Usuários..");
                DateTime time8 = DateTime.Now;
                Game.Destroy();
                Logging.WriteLine("Emulação de Jogo Encerrando..");
                DateTime time9 = DateTime.Now;
                try
                {
                    Logging.WriteLine("Encerrando Conexões..");
                    manager.destroy();
                    managerItems.destroy();
                    ConnectionManager.Destroy();
                }
                catch
                {
                }
                AppendTimeStampWithComment(ref builder, time9, " (Encerramento da DB)");
                TimeSpan span = (TimeSpan)(DateTime.Now - now);
                builder.AppendLine("Tempo de Desligamento " + TimeSpanToString(span));
                builder.AppendLine("You have reached ==> [END OF SESSION]");
                builder.AppendLine();
                builder.AppendLine();
                builder.AppendLine();
                Logging.LogShutdown(builder);
                Console.ResetColor();
                Console.Clear();
                Console.WriteLine();
                Console.BackgroundColor = ConsoleColor.Blue;
                Console.ForegroundColor = ConsoleColor.White;
                Console.Beep();
                Console.WriteLine(@"                                                                               ");
                Console.WriteLine(@"[Swift] Emulador Desligado. Esperando Ser Ligado Denovo.                       ");
                Console.WriteLine(@"_______________________________________________________________________________");
                Console.BackgroundColor = ConsoleColor.Black;
                Console.WriteLine();
                
            }
        }

        internal static void SendMassMessage(string Message)
        {
            try
            {
                ServerMessage message = new ServerMessage(Outgoing.BroadcastMessage);
                message.AppendString(Message);
                GetGame().GetClientManager().QueueBroadcaseMessage(message);
            }
            catch (Exception exception)
            {
                Logging.HandleException(exception, "SwiftEmuEnvironment.SendMassMessage");
            }
        }

        internal static string TimeSpanToString(TimeSpan span)
        {
            return string.Concat(new object[] { span.Seconds, " segundos, ", span.Milliseconds, " milisegundos" });
        }

        internal static bool ShutdownStarted
        {
            get
            {
                return ShutdownInitiated;
            }
        }

        public static ConfigurationData DatabaseConfiguration { get; set; }
    }


}

